Index: vendors/IOIPSL/current/example/testflio.f90
===================================================================
--- vendors/IOIPSL/current/example/testflio.f90	(revision 1989)
+++ vendors/IOIPSL/current/example/testflio.f90	(revision 1991)
@@ -1,5 +1,5 @@
 PROGRAM testflio
 !-
-!$Id: testflio.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: testflio.f90 887 2010-02-08 09:48:39Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -106,5 +106,5 @@
   CALL fliodefv (fid,'my_var_1',(/ 5 /), &
  &               v_t=flio_r4,units='1',long_name='my_var_1', &
- &               valid_min=-10.,valid_max=+20.)
+ &               valid_min=-10.,valid_max=+20.,fillvalue=+50.)
   CALL fliodefv (fid,'Var_vr4', &
  &               v_t=flio_r4,units='1',long_name='Var_vr4')
Index: vendors/IOIPSL/current/example/testhist1.f90
===================================================================
--- vendors/IOIPSL/current/example/testhist1.f90	(revision 1989)
+++ vendors/IOIPSL/current/example/testhist1.f90	(revision 1991)
@@ -1,5 +1,5 @@
 PROGRAM testhist1
 !-
-!$Id: testhist1.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: testhist1.f90 807 2009-11-23 12:11:55Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -72,13 +72,13 @@
   CALL histdef (id,"champ1","Some field","m", &
  &       iim,jjm,hori_id,1,1,1,-99,32,"inst(scatter(x))", &
- &       dt_op,dt_wrt,var_range=(/1.,-1./))
+ &       dt_op,dt_wrt,var_range=(/1.,-1./),standard_name='thickness')
 !-
   CALL histdef (id,"champ2","Another field","m", &
  &       iim,jjm,hori_id,llm,1,llm,sig_id,32,"t_max(max(x,1.0)*2)", &
- &       deltat,dt_wrt,var_range=(/0.,90./))
+ &       deltat,dt_wrt,var_range=(/0.,90./),standard_name='thickness')
 !-
   CALL histdef (id,"champ3","A field without time","m", &
  &       iim,jjm,hori_id,1,1,1,-99, 32,"once", &
- &       deltat,dt_wrt)
+ &       deltat,dt_wrt,standard_name='thickness')
 !-
   CALL histend (id)
Index: vendors/IOIPSL/current/example/testhist2.f90
===================================================================
--- vendors/IOIPSL/current/example/testhist2.f90	(revision 1989)
+++ vendors/IOIPSL/current/example/testhist2.f90	(revision 1991)
@@ -1,5 +1,5 @@
 PROGRAM testhist2
 !-
-!$Id: testhist2.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: testhist2.f90 807 2009-11-23 12:11:55Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -76,9 +76,9 @@
   CALL histvert (id,"sigma","Sigma levels"," ",llm,lev,sig_id,pdirect="up")
 !-
-  CALL histdef (id,"champ1","Some field","m", &
- &       iim,jjm,hori_id,1,1,1,-99,32,"t_sum",dt_op,dt_wrt)
+  CALL histdef (id,"champ1","Some field","m",iim,jjm,hori_id, &
+ &  1,1,1,-99,32,"t_sum",dt_op,dt_wrt,standard_name='thickness')
 !-
-  CALL histdef (id,"champ2","summed field","m", &
- &       iim,jjm,hori_id,1,1,1,-99,32,"t_sum",dt_op,dt_wrt)
+  CALL histdef (id,"champ2","summed field","m",iim,jjm,hori_id, &
+ &  1,1,1,-99,32,"t_sum",dt_op,dt_wrt,standard_name='thickness')
 !-
   CALL histend (id)
@@ -92,9 +92,9 @@
   CALL histvert (id2,"sigma","Sigma levels"," ",llm,lev,sig_id,pdirect="up")
 !-
-  CALL histdef (id2,"champ1","Some field","m", &
- &       iim,jjm,hori_id,1,1,1,-99,32,"t_sum",dt_op2,dt_wrt2)
+  CALL histdef (id2,"champ1","Some field","m",iim,jjm,hori_id, &
+ &  1,1,1,-99,32,"t_sum",dt_op2,dt_wrt2,standard_name='thickness')
 !-
-  CALL histdef (id2,"champ2","summed field","m", &
- &       iim,jjm,hori_id,1,1,1,-99,32,"t_sum",dt_op2,dt_wrt2)
+  CALL histdef (id2,"champ2","summed field","m",iim,jjm,hori_id, &
+ &  1,1,1,-99,32,"t_sum",dt_op2,dt_wrt2,standard_name='thickness')
 !-
   CALL histend (id2)
Index: vendors/IOIPSL/current/example/testopp.f90
===================================================================
--- vendors/IOIPSL/current/example/testopp.f90	(revision 1989)
+++ vendors/IOIPSL/current/example/testopp.f90	(revision 1991)
@@ -1,5 +1,5 @@
 PROGRAM testopp
 !-
-!$Id: testopp.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: testopp.f90 846 2009-12-10 16:26:58Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -34,12 +34,11 @@
      WRITE(*,*) ' '
      WRITE(*,*) 'String to be analyzed : ',TRIM(opp)
-     CALL buildop (opp,ex_topps,tmp_topp,nbopp_max,missing_val, &
-    &              tmp_sopp,tmp_scal,nbopp)
+     CALL buildop (TRIM(opp),ex_topps,tmp_topp,missing_val, &
+ &                 tmp_sopp,tmp_scal,nbopp)
 !-
-     WRITE(*,*) 'Time operation : ',TRIM(tmp_topp)
-     WRITE(*,*) 'Other operations  :', nbopp
+     WRITE(*,*) 'Time operation   : ',TRIM(tmp_topp)
+     WRITE(*,*) 'Other operations : ',nbopp
      DO i=1,nbopp
-       WRITE(*,*) 'i = ',i,' opp : ',tmp_sopp(i), &
-      &           ' scalar : ',tmp_scal(i)
+       WRITE(*,*) ' ',i,' opp : ',tmp_sopp(i),' scalar : ',tmp_scal(i)
      ENDDO
    ENDDO
Index: vendors/IOIPSL/current/src/calendar.f90
===================================================================
--- vendors/IOIPSL/current/src/calendar.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/calendar.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE calendar
 !-
-!$Id: calendar.f90 693 2009-07-29 15:49:31Z bellier $
+!$Id: calendar.f90 1011 2010-05-07 13:05:34Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -511,5 +511,5 @@
 !- action is smaller than the one from the next expected
 !- check to the next action.
-!- When the test is done on the time steps simplifactions make
+!- When the test is done on the time steps simplifications make
 !- it more difficult to read in the code.
 !- For the real time case it is easier to understand !
Index: vendors/IOIPSL/current/src/errioipsl.f90
===================================================================
--- vendors/IOIPSL/current/src/errioipsl.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/errioipsl.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE errioipsl
 !-
-!$Id: errioipsl.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: errioipsl.f90 759 2009-10-22 08:53:27Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -80,5 +80,6 @@
    ENDIF
    IF ( (plev == 3).AND.lact_mode) THEN
-     STOP 'Fatal error from IOIPSL. See stdout for more details'
+     WRITE(n_l,'("Fatal error from IOIPSL. STOP in ipslerr with code")')
+     STOP 1
    ENDIF
 !---------------------
Index: vendors/IOIPSL/current/src/fliocom.f90
===================================================================
--- vendors/IOIPSL/current/src/fliocom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/fliocom.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE fliocom
 !-
-!$Id: fliocom.f90 386 2008-09-04 08:38:48Z bellier $
+!$Id: fliocom.f90 965 2010-04-07 08:38:54Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -12,5 +12,5 @@
  &                    ioconf_calendar,ju2ymds,ymds2ju
 USE errioipsl, ONLY : ipslerr,ipsldbg
-USE stringop,  ONLY : strlowercase
+USE stringop,  ONLY : strlowercase,str_xfw
 !-
 IMPLICIT NONE
@@ -86,12 +86,14 @@
 !!              This argument can be equal to FLIO_DOM_DEFAULT
 !!              (see "flio_dom_defset").
-!! (C) mode   : Mode used to create the file.
-!!              Supported modes : REPLACE, REP, 32, 64, REP32, REP64.
-!!              If this argument is present with the value "REP[32/64]"
-!!              or the value "REPLACE", the file will be created
-!!              in mode "CLOBBER", else the file will be created
-!!              in mode "NOCLOBBER".
+!! (C) mode   : String of (case insensitive) blank-separated words
+!!              defining the mode used to create the file.
+!!              Supported keywords : REPLACE, 32, 64
+!!              If this argument is present with the keyword "REPLACE",
+!!              the file will be created in mode "CLOBBER",
+!!              else the file will be created in mode "NOCLOBBER".
 !!              "32/64" defines the offset mode.
-!!              The default offset mode is 32 bits.
+!!              The default offset mode is 64 bits.
+!!              Keywords "NETCDF4" and "CLASSIC" are reserved
+!!              for future use.
 !!
 !! Optional OUTPUT arguments
@@ -205,5 +207,6 @@
 !! SUBROUTINE fliodefv &
 !! & (f_i,v_n,[v_d],v_t, &
-!! &  axis,standard_name,long_name,units,valid_min,valid_max)
+!! &  axis,standard_name,long_name,units, &
+!! &  valid_min,valid_max,fillvalue)
 !!
 !! INPUT
@@ -227,5 +230,5 @@
 !! (C) axis,standard_name,long_name,units : Attributes
 !!     (axis should be used only for coordinates)
-!! (R) valid_min,valid_max : Attributes
+!! (R) valid_min,valid_max,fillvalue : Attributes
 !!--------------------------------------------------------------------
   MODULE PROCEDURE &
@@ -805,5 +808,5 @@
 !-
 ! Maximum number of simultaneously defined domains
-  INTEGER,PARAMETER :: dom_max_nb=10
+  INTEGER,PARAMETER :: dom_max_nb=64
 !-
 ! Maximum number of distributed dimensions for each domain
@@ -848,4 +851,14 @@
   INTEGER :: i_rc,f_e,idid,ii,m_c,n_u
   CHARACTER(LEN=NF90_MAX_NAME) :: f_nw
+  INTEGER,PARAMETER :: l_string=80,l_word=10
+  CHARACTER(LEN=l_string) :: c_string
+  CHARACTER(LEN=l_word)   :: c_word
+  LOGICAL :: l_ok
+  INTEGER,PARAMETER :: k_replace=1
+  INTEGER,PARAMETER :: k_32=1,k_64=2
+!- !? : Code to be activated for NETCDF4
+!?  INTEGER,PARAMETER :: k_netcdf4=1,k_classic=1
+  INTEGER,PARAMETER :: n_opt=4
+  INTEGER,DIMENSION(n_opt) :: i_opt
 !-
   LOGICAL :: l_dbg
@@ -881,20 +894,89 @@
 !-
 ! Check the mode
+!-
+  i_opt(:)=-1
+!-
   IF (PRESENT(mode)) THEN
-    SELECT CASE (TRIM(mode))
-    CASE('REPLACE','REP','REP32')
-      m_c = NF90_CLOBBER
-    CASE('32')
-      m_c = NF90_NOCLOBBER
-    CASE('64')
-      m_c = IOR(NF90_NOCLOBBER,NF90_64BIT_OFFSET)
-    CASE('REP64')
-      m_c = IOR(NF90_CLOBBER,NF90_64BIT_OFFSET)
-    CASE DEFAULT
-      m_c = NF90_NOCLOBBER
-    END SELECT
+!---
+    IF (LEN_TRIM(mode) > l_string) THEN
+      CALL ipslerr (3,'fliocrfd', &
+ &     '"mode" argument','too long','to be treated')
+    ENDIF
+    c_string = mode(:)
+    CALL strlowercase (c_string)
+!---
+    DO
+      CALL str_xfw  (c_string,c_word,l_ok)
+      IF (l_ok) THEN
+!- !? : Code to be activated for NETCDF4
+        SELECT CASE (TRIM(c_word))
+        CASE('replace')
+          IF (i_opt(1) > 0) THEN
+            CALL ipslerr (3,'fliocrfd', &
+ &           'Replace option','already','defined')
+          ELSE
+            i_opt(1) = k_replace
+          ENDIF
+!?      CASE('netcdf4')
+!?        IF (i_opt(2) > 0) THEN
+!?          CALL ipslerr (3,'fliocrfd', &
+!? &         'Netcdf4 format','already','defined')
+!?        ELSE
+!?          i_opt(2) = k_netcdf4
+!?        ENDIF
+        CASE('32')
+          IF (i_opt(3) > 0) THEN
+            CALL ipslerr (3,'fliocrfd', &
+ &           'Offset format','already','defined')
+          ELSE
+            i_opt(3) = k_32
+          ENDIF
+        CASE('64')
+          IF (i_opt(3) > 0) THEN
+            CALL ipslerr (3,'fliocrfd', &
+ &           'Offset format','already','defined')
+          ELSE
+            i_opt(3) = k_64
+          ENDIF
+!?      CASE('CLASSIC')
+!?        IF (i_opt(4) > 0) THEN
+!?          CALL ipslerr (3,'fliocrfd', &
+!? &         'Netcdf4 classic format','already','defined')
+!?        ELSE
+!?          i_opt(4) = k_classic
+!?        ENDIF
+        CASE DEFAULT
+          CALL ipslerr (3,'fliocrfd', &
+ &         'Option '//TRIM(c_word),'not','supported')
+        END SELECT
+      ELSE
+        EXIT
+      ENDIF
+    ENDDO
+  ENDIF
+!-
+  IF (i_opt(1) == k_replace) THEN
+    m_c = NF90_CLOBBER
   ELSE
     m_c = NF90_NOCLOBBER
   ENDIF
+!-
+!- Code to be replaced by the following for NETCDF4
+!?  IF (i_opt(2) == k_netcdf4) THEN
+!?    m_c = IOR(m_c,NF90_NETCDF4)
+!?    IF (i_opt(3) > 0) THEN
+!?      CALL ipslerr (3,'fliocrfd', &
+!? &     'Netcdf4 format','and offset option','are not compatible')
+!?    ELSE IF (i_opt(4) == k_classic) THEN
+!?      m_c = IOR(m_c,NF90_CLASSIC_MODEL)
+!?    ENDIF
+!?   LSE IF (i_opt(4) > 0) THEN
+!?    CALL ipslerr (3,'fliocrfd', &
+!? &   'Classic option','is reserved','for the Netcdf4 format')
+!?  ELSE
+    IF (i_opt(3) /= k_32) THEN
+      m_c = IOR(m_c,NF90_64BIT_OFFSET)
+    ENDIF
+!?  ENDIF
 !-
 ! Create file (and enter the definition mode)
@@ -1229,5 +1311,5 @@
 ! Ensuring data mode
 !-
-    CALL flio_hdm (f_i,f_e,.FALSE.)
+  CALL flio_hdm (f_i,f_e,.FALSE.)
 !-
 ! Create the longitude axis
@@ -1287,5 +1369,5 @@
 SUBROUTINE fliodv_r0d &
  & (f_i,v_n,v_t, &
- &  axis,standard_name,long_name,units,valid_min,valid_max)
+ &  axis,standard_name,long_name,units,valid_min,valid_max,fillvalue)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -1296,9 +1378,9 @@
   CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: &
  & axis,standard_name,long_name,units
-  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max
+  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max,fillvalue
 !---------------------------------------------------------------------
   CALL flio_udv &
  &  (f_i,0,v_n,(/0/),v_t, &
- &   axis,standard_name,long_name,units,valid_min,valid_max)
+ &   axis,standard_name,long_name,units,valid_min,valid_max,fillvalue)
 !------------------------
 END SUBROUTINE fliodv_r0d
@@ -1306,5 +1388,5 @@
 SUBROUTINE fliodv_rnd &
  & (f_i,v_n,v_d,v_t, &
- &  axis,standard_name,long_name,units,valid_min,valid_max)
+ &  axis,standard_name,long_name,units,valid_min,valid_max,fillvalue)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -1316,9 +1398,9 @@
   CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: &
  & axis,standard_name,long_name,units
-  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max
+  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max,fillvalue
 !---------------------------------------------------------------------
   CALL flio_udv &
  &  (f_i,SIZE(v_d),v_n,v_d,v_t, &
- &   axis,standard_name,long_name,units,valid_min,valid_max)
+ &   axis,standard_name,long_name,units,valid_min,valid_max,fillvalue)
 !------------------------
 END SUBROUTINE fliodv_rnd
@@ -1326,5 +1408,5 @@
 SUBROUTINE flio_udv &
  & (f_i,n_d,v_n,v_d,v_t, &
- &  axis,standard_name,long_name,units,valid_min,valid_max)
+ &  axis,standard_name,long_name,units,valid_min,valid_max,fillvalue)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -1336,5 +1418,5 @@
   CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: &
  & axis,standard_name,long_name,units
-  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max
+  REAL,OPTIONAL,INTENT(IN) :: valid_min,valid_max,fillvalue
 !-
   INTEGER :: f_e,m_k,i_v,i_rc,ii,idd
@@ -1380,7 +1462,8 @@
 !---
     IF (PRESENT(v_t)) THEN
-      IF      (v_t == flio_i) THEN
+      SELECT CASE (v_t)
+      CASE(flio_i)
         IF (i_std == i_8) THEN
-!-------- Not yet supported by NETCDF
+!-------- I8 not yet supported by NETCDF
 !-------- m_k = flio_i8
           m_k = flio_i4
@@ -1388,5 +1471,5 @@
           m_k = flio_i4
         ENDIF
-      ELSE IF (v_t == flio_r) THEN
+      CASE(flio_r)
         IF (r_std == r_8) THEN
           m_k = flio_r8
@@ -1394,7 +1477,10 @@
           m_k = flio_r4
         ENDIF
-      ELSE
+      CASE(flio_c,flio_i1,flio_i2,flio_i4,flio_r4,flio_r8)
         m_k = v_t
-      ENDIF
+      CASE DEFAULT
+        CALL ipslerr (3,'fliodefv', &
+ &        'Variable '//TRIM(v_n),'External type','not supported')
+      END SELECT
     ELSE IF (r_std == r_8) THEN
       m_k = flio_r8
@@ -1402,4 +1488,5 @@
       m_k = flio_r4
     ENDIF
+!---
     IF (n_d > 0) THEN
       i_rc = NF90_DEF_VAR(f_e,v_n,m_k,a_i(1:n_d),i_v)
@@ -1427,8 +1514,50 @@
     ENDIF
     IF (PRESENT(valid_min)) THEN
-      i_rc = NF90_PUT_ATT(f_e,i_v,'valid_min',valid_min)
+      SELECT CASE (m_k)
+      CASE(flio_i1,flio_i2)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_min',NINT(valid_min,KIND=i_2))
+      CASE(flio_i4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_min',NINT(valid_min,KIND=i_4))
+      CASE(flio_r4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_min',REAL(valid_min,KIND=r_4))
+      CASE(flio_r8)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_min',REAL(valid_min,KIND=r_8))
+      CASE DEFAULT
+        CALL ipslerr (2,'fliodefv', &
+   &      'Variable '//TRIM(v_n),'attribute valid_min', &
+   &      'not supported for this external type')
+      END SELECT
     ENDIF
     IF (PRESENT(valid_max)) THEN
-      i_rc = NF90_PUT_ATT(f_e,i_v,'valid_max',valid_max)
+      SELECT CASE (m_k)
+      CASE(flio_i1,flio_i2)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_max',NINT(valid_max,KIND=i_2))
+      CASE(flio_i4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_max',NINT(valid_max,KIND=i_4))
+      CASE(flio_r4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_max',REAL(valid_max,KIND=r_4))
+      CASE(flio_r8)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'valid_max',REAL(valid_max,KIND=r_8))
+      CASE DEFAULT
+        CALL ipslerr (2,'fliodefv', &
+   &      'Variable '//TRIM(v_n),'attribute valid_max', &
+   &      'not supported for this external type')
+      END SELECT
+    ENDIF
+    IF (PRESENT(fillvalue)) THEN
+      SELECT CASE (m_k)
+      CASE(flio_i1,flio_i2)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'_FillValue',NINT(fillvalue,KIND=i_2))
+      CASE(flio_i4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'_FillValue',NINT(fillvalue,KIND=i_4))
+      CASE(flio_r4)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'_FillValue',REAL(fillvalue,KIND=r_4))
+      CASE(flio_r8)
+        i_rc = NF90_PUT_ATT(f_e,i_v,'_FillValue',REAL(fillvalue,KIND=r_8))
+      CASE DEFAULT
+        CALL ipslerr (2,'fliodefv', &
+   &      'Variable '//TRIM(v_n),'attribute fillvalue', &
+   &      'not supported for this external type')
+      END SELECT
     ENDIF
 !---
@@ -2177,5 +2306,5 @@
 !-
   IF (PRESENT(mode)) THEN
-    IF (TRIM(MODE) == "WRITE") THEN
+    IF (TRIM(mode) == "WRITE") THEN
       m_c = NF90_WRITE
     ELSE
@@ -4893,5 +5022,5 @@
   INTEGER :: kv,k,n_r,l_d,n_d,i_rc,dimnb
   CHARACTER(LEN=1)  :: c_ax
-  CHARACTER(LEN=9)  :: c_sn
+  CHARACTER(LEN=18) :: c_sn
   CHARACTER(LEN=15),DIMENSION(10) :: c_r
   CHARACTER(LEN=40) :: c_t1,c_t2
Index: vendors/IOIPSL/current/src/getincom.f90
===================================================================
--- vendors/IOIPSL/current/src/getincom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/getincom.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE getincom
 !-
-!$Id: getincom.f90 536 2009-01-30 11:46:27Z bellier $
+!$Id: getincom.f90 963 2010-03-31 15:26:11Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -13,5 +13,19 @@
 !-
 PRIVATE
-PUBLIC :: getin, getin_dump
+PUBLIC :: getin_name, getin, getin_dump
+!-
+!!--------------------------------------------------------------------
+!! The "getin_name" routine allows the user to change the name
+!! of the definition file in which the data will be read.
+!! ("run.def" by default)
+!!
+!!  SUBROUTINE getin_name (file_name)
+!!
+!! OPTIONAL INPUT argument
+!!
+!! (C) file_name :  the name of the file
+!!                  in which the data will be read
+!!--------------------------------------------------------------------
+!-
 !-
 INTERFACE getin
@@ -19,5 +33,5 @@
 !! The "getin" routines get a variable.
 !! We first check if we find it in the database
-!! and if not we get it from the run.def file.
+!! and if not we get it from the definition file.
 !!
 !! SUBROUTINE getin (target,ret_val)
@@ -41,5 +55,5 @@
 !!--------------------------------------------------------------------
 !! The "getin_dump" routine will dump the content of the database
-!! into a file which has the same format as the run.def file.
+!! into a file which has the same format as the definition file.
 !! The idea is that the user can see which parameters were used
 !! and re-use the file for another run.
@@ -57,4 +71,7 @@
   INTEGER,SAVE      :: nbfiles
 !-
+  INTEGER,SAVE :: allread=0
+  CHARACTER(LEN=100),SAVE :: def_file = 'run.def'
+!-
   INTEGER,PARAMETER :: i_txtslab=1000,l_n=30
   INTEGER,SAVE :: nb_lines,i_txtsize=0
@@ -78,5 +95,5 @@
 !-
 ! keystatus definition
-! keystatus = 1 : Value comes from run.def
+! keystatus = 1 : Value comes from the file defined by 'def_file'
 ! keystatus = 2 : Default value is used
 ! keystatus = 3 : Some vector elements were taken from default
@@ -112,4 +129,22 @@
 !-
 CONTAINS
+!-
+!=== DEFINITION FILE NAME INTERFACE
+!-
+SUBROUTINE getin_name (cname)
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  CHARACTER(LEN=*) :: cname
+!---------------------------------------------------------------------
+  IF (allread == 0) THEN
+    def_file = ADJUSTL(cname)
+  ELSE
+    CALL ipslerr (3,'getin_name', &
+ &   'The name of the database file (any_name.def)', &
+ &   'must be changed *before* any attempt','to read the database.')
+  ENDIF
+!------------------------
+END SUBROUTINE getin_name
 !-
 !=== INTEGER INTERFACE
@@ -1008,5 +1043,4 @@
   IMPLICIT NONE
 !-
-  INTEGER,SAVE :: allread=0
   INTEGER,SAVE :: current
 !---------------------------------------------------------------------
@@ -1021,5 +1055,5 @@
 !-- Start with reading the files
     nbfiles = 1
-    filelist(1) = 'run.def'
+    filelist(1) = TRIM(def_file)
     current = 1
 !--
@@ -1146,5 +1180,5 @@
 !-
   IF (check) THEN
-    OPEN (UNIT=22,file='run.def.test')
+    OPEN (UNIT=22,file=TRIM(def_file)//'.test')
     DO i=1,nb_lines
       WRITE(UNIT=22,FMT=*) targetlist(i)," : ",fichier(i)
@@ -1416,5 +1450,4 @@
 !-
   TYPE(t_key),ALLOCATABLE,DIMENSION(:) :: tmp_key_tab
-  CHARACTER(LEN=100),ALLOCATABLE :: tmp_str(:)
 !-
   INTEGER :: ier
@@ -1787,5 +1820,5 @@
         CASE(1)
           WRITE(22,*) '# Values of ', &
- &          TRIM(key_tab(ikey)%keystr),' comes from the run.def.'
+ &          TRIM(key_tab(ikey)%keystr),' comes from ',TRIM(def_file)
         CASE(2)
           WRITE(22,*) '# Values of ', &
@@ -1794,5 +1827,5 @@
           WRITE(22,*) '# Values of ', &
  &          TRIM(key_tab(ikey)%keystr), &
- &          ' are a mix of run.def and defaults.'
+ &          ' are a mix of ',TRIM(def_file),' and defaults.'
         CASE DEFAULT
           WRITE(22,*) '# Dont know from where the value of ', &
